// AddChapter.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "ToolTipDialog.h"
#include "AddChapter.h"
#include "AddChapterDlg.h"


//#include <Winbase.h>


#define INI_AUDIO  0x204
#define INI_SUBS   0x256
#define INI_VIDEO  0x200
#define HEADLENGTH 0x3D8

typedef unsigned char uchar;
#include "FixedVobs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern void MyInfoBox(LPCTSTR text);
extern void MyErrorBox(LPCTSTR text);
extern int GetNbytes(int nNumber,uchar* address);
extern DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2);
extern void Put4bytes(__int64 i64Number,uchar* address);
extern void Put2bytes(__int64 i64Number,uchar* address);
extern bool IsNav(uchar* buffer);
extern bool IsSynch (uchar* buffer);
extern void writebuffer(uchar *caracter, FILE *out);
extern void ModifyLBA (uchar* buffer, __int64 m_i64OutputLBA);
extern void ModifyCID (uchar* buffer, int VobId, int CellId);
extern int readbuffer(uchar *caracter, FILE *in);
extern DWORD FramesToDuration(int nFrames,int fps);



/////////////////////////////////////////////////////////////////////////////
// CAddChapterApp

BEGIN_MESSAGE_MAP(CAddChapterApp, CWinApp)
	//{{AFX_MSG_MAP(CAddChapterApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddChapterApp construction

CAddChapterApp::CAddChapterApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAddChapterApp object

CAddChapterApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAddChapterApp initialization

BOOL CAddChapterApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	IniMembers();

	CAddChapterDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CAddChapterApp::IniMembers()
{

// members initialization
	int i;


	for (i=0;i<MAXPGCS;i++)
	{
		m_BAdd[i]=FALSE;
		m_nCells[i]=m_nChapters[i]=m_nPrograms[i]=0;
		m_dwDuration[i]=m_dwDurationLC[i]=0;
		m_nInVTS[i]=m_nInVMG[i]=0;
		m_i64CellSize[i]=5; // Size of Blank Cell;
		m_iStillTime[i]=0;
		m_iCellType[i]=0;
	}
	for (i=0;i<MAXTITLES;i++)
		m_nTChapters[i]=0;
	m_nVOBs=m_nPGCs=m_nVTS=0;
	m_nNewIFOSec=0;
}

int CAddChapterApp::ReadIFOs()
{

	FILE *in;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	int i, k, iRet;

	m_csInputIFO.MakeUpper();
	m_csInputVMG=m_csInputPath + '\\' + "VIDEO_TS.IFO";

// Read VTS_XX_0.IFO
	if ((in=fopen(m_csInputIFO,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input file: " + m_csInputIFO);
		return -1;
	}
	for (i=0;!feof(in) && i< MAXLENGTH ;i++)
		m_pVTS[i]=fgetc(in);
	m_i64VTSlen=i-1;
	
	fclose(in);

	if (m_i64VTSlen == MAXLENGTH-1)
	{
		MyErrorBox ("ERROR: Ifo file too big: "+m_csInputIFO);
		return -1;
	}

// Read VIDEO_TS.IFO
	if ((in=fopen(m_csInputVMG,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input file: " + m_csInputVMG);
		return -1;
	}
	for (i=0;!feof(in) && i< MAXLENGTH ;i++)
		m_pVMG[i]=fgetc(in);
	m_i64VMGlen=i-1;
	
	fclose(in);

	if (m_i64VMGlen == MAXLENGTH-1)
	{
		MyErrorBox ("ERROR: Ifo file too big: "+m_csInputVMG);
		return -1;
	}

////////// Find Last VOB  and size //////////////////////////////////
	csAux=m_csInputIFO.Right(8);
	csAux=csAux.Left(2);
	if ( sscanf (csAux,"%d", & m_nVTS)!=1 )
	{
		MyErrorBox ("ERROR: Unable to get VTS number from: " +m_csInputIFO);
		return -1;
	}

	m_i64VTSsize=0;
	for (k=1; k<10; k++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), m_nVTS,k);
		csAux=m_csInputPath + '\\' + csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
		{
			m_nVOBs=k;
			m_i64LastVOBSize=statbuf.st_size;
			m_i64VTSsize+= statbuf.st_size;
		}
		else 
			k=20;
	}
////////// Fill Data to be displayed in Dialog /////////////

	m_TT_SRPT		=	2048*GetNbytes(4,&m_pVMG[0xC4]);
	m_nTotalTitles	=	GetNbytes(2,&m_pVMG[m_TT_SRPT]);


	iRet=FillVTSvars();

	return iRet;
}


int CAddChapterApp::FillVTSvars()
{
	int k,nT, nPGC, nChap;
	int LastChP,EntryCell,nCell;
	DWORD dwCellDuration;


	m_VTS_PTT_SRPT	=	2048*GetNbytes(4,&m_pVTS[0xC8]);
	m_VTS_PGCI		=	2048*GetNbytes(4,&m_pVTS[0xCC]);
	m_VTSM_PGCI_UT	=	2048*GetNbytes(4,&m_pVTS[0xD0]);
	m_VTS_TMAPTI	=	2048*GetNbytes(4,&m_pVTS[0xD4]);
	m_VTSM_C_ADT	=	2048*GetNbytes(4,&m_pVTS[0xD8]);
	m_VTSM_VOBU_ADMAP=	2048*GetNbytes(4,&m_pVTS[0xDC]);
	m_VTS_C_ADT		=	2048*GetNbytes(4,&m_pVTS[0xE0]);
	m_VTS_VOBU_ADMAP=	2048*GetNbytes(4,&m_pVTS[0xE4]);
	m_nPGCs			=	GetNbytes(2,&m_pVTS[m_VTS_PGCI]);
	m_iVideoAttr	=	m_pVTS[0x200]*256+m_pVTS[0x201];
	m_iFormat		=	(m_iVideoAttr & 0x1000) >> 12;
	m_nTitles		=	GetNbytes(2,&m_pVTS[m_VTS_PTT_SRPT]);


	// nT indexes Titles
	for (nT=0; nT<m_nTitles; nT++)
	{
		m_VTS_PTT[nT]	=	GetNbytes(4,&m_pVTS[m_VTS_PTT_SRPT + 8+4*nT])+m_VTS_PTT_SRPT;
		if (nT != (m_nTitles-1))
			m_VTS_PTT_L[nT]	=	GetNbytes(4,&m_pVTS[m_VTS_PTT_SRPT + 8+4*(nT+1)])+m_VTS_PTT_SRPT;
		else
			m_VTS_PTT_L[nT]	=	GetNbytes(4,&m_pVTS[m_VTS_PTT_SRPT + 4])+ m_VTS_PTT_SRPT + 1;

		m_nTChapters[nT]	=	(m_VTS_PTT_L[nT]- m_VTS_PTT[nT])/4;
	}

// nPGC indexes PGCs

	for (nPGC=0; nPGC<m_nPGCs; nPGC++)
	{
		m_nInVTS[nPGC]= m_pVTS[m_VTS_PGCI+0x08+nPGC*8] & 0x7f;
		nT=m_nInVTS[nPGC]-1;
		for (k=0; k<m_nTotalTitles;k++)
		{
			if (m_pVMG[m_TT_SRPT+8+12*k+6]==(uchar) m_nVTS &&
				m_pVMG[m_TT_SRPT+8+12*k+7]==(uchar) m_nInVTS[nPGC] )
					m_nInVMG[nPGC]=k+1;
		}

		m_VTS_PGC[nPGC]		=	GetNbytes(4,&m_pVTS[m_VTS_PGCI+0x04+0x08+nPGC*8])+m_VTS_PGCI;
		m_dwDuration[nPGC]	=	(DWORD)GetNbytes(4,&m_pVTS[m_VTS_PGC[nPGC]+4]);
		m_PGM_MAP[nPGC]		=	GetNbytes(2,&m_pVTS[m_VTS_PGC[nPGC]+0xE6])+m_VTS_PGC[nPGC];
		m_C_PBKT[nPGC]		=	GetNbytes(2,&m_pVTS[m_VTS_PGC[nPGC]+0xE8])+m_VTS_PGC[nPGC];
		m_C_POST[nPGC]		=	GetNbytes(2,&m_pVTS[m_VTS_PGC[nPGC]+0xEA])+m_VTS_PGC[nPGC];
		m_nPrograms[nPGC]	=	m_pVTS[m_VTS_PGC[nPGC]+2];
		m_nCells[nPGC]		=	m_pVTS[m_VTS_PGC[nPGC]+3];
		if ( m_pVTS[m_VTS_PGCI+0x08+nPGC*8] & 0x80 )
			m_bEntryPGC[nPGC]	=	true;
		else
			m_bEntryPGC[nPGC]	=	false;

// Loop in Chapters
		m_nChapters[nPGC]=0;

		for (nChap=0; nChap<m_nTChapters[nT]; nChap++)
		{
			if ((nPGC+1) == GetNbytes(2,&m_pVTS[m_VTS_PTT[nT]+4*nChap]) )
			{
				m_nChapters[nPGC]++;
				// Get Program number
				LastChP=GetNbytes(2,&m_pVTS[m_VTS_PTT[nT]+4*nChap+2]);
			}
		}

		m_dwDurationLC[nPGC]=0;
		if (m_nChapters[nPGC])
		{
			EntryCell=m_pVTS[m_PGM_MAP[nPGC]+LastChP-1]-1;
			for (nCell=EntryCell; nCell< m_nCells[nPGC];nCell++)
			{
				dwCellDuration=GetNbytes(4, &m_pVTS[m_C_PBKT[nPGC]+nCell*24+4]);
				m_dwDurationLC[nPGC]= AddDuration(dwCellDuration,m_dwDurationLC[nPGC]);
			}
		}

	}
	return 0;
}


int CAddChapterApp::BackupIFOs()
{
	FILE *out;
	CString csAux,csAux2;
	int i;

	csAux=m_csBackupPath + "\\VIDEO_TS.IFO" ;
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open backup file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VMGlen; i++)
		fputc (m_pVMG[i],out);

	fclose(out);

	csAux=m_csBackupPath + "\\VIDEO_TS.BUP" ;
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open backup file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VMGlen; i++)
		fputc (m_pVMG[i],out);

	fclose(out);

	csAux2.Format(_T("VTS_%02d_0.IFO"),m_nVTS);
	csAux=m_csBackupPath + '\\' + csAux2;
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open backup file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VTSlen; i++)
		fputc (m_pVTS[i],out);

	fclose(out);

	csAux2.Format(_T("VTS_%02d_0.BUP"),m_nVTS);
	csAux=m_csBackupPath + '\\' + csAux2;
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open backup file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VTSlen; i++)
		fputc (m_pVTS[i],out);

	fclose(out);

	return 0;
}


int CAddChapterApp::WriteIFOs()
{
	FILE *out;
	int i;
	CString csAux;

	if ((out=fopen(m_csInputIFO,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open file: " + m_csInputIFO +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VTSlen; i++)
		fputc (m_pVTS[i],out);

	fclose(out);


	if ((out=fopen(m_csInputVMG,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open file: " + m_csInputVMG +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VMGlen; i++)
		fputc (m_pVMG[i],out);

	fclose(out);

	csAux=m_csInputIFO.Left(m_csInputIFO.GetLength()-3);
	csAux=csAux+"BUP";
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VTSlen; i++)
		fputc (m_pVTS[i],out);

	fclose(out);

	csAux=m_csInputVMG.Left(m_csInputVMG.GetLength()-3);
	csAux=csAux+"BUP";
	if ((out=fopen(csAux,"wb"))==NULL)
	{
		MyErrorBox ("Unable to open file: " + csAux +".Aborting.");
		return -1;
	}

	for (i=0; i<m_i64VMGlen; i++)
		fputc (m_pVMG[i],out);

	fclose(out);

	return 0;

}

void CAddChapterApp::RemoveMenuPUOPS(uchar* pIFO)
{
///////////////////////////////////////////////////////
//  Menu PGCs loop

	int VTSM_PGCI_UT, VTSM_LU, VTSM_PGC;
	int nTotalLU, nLU, nTotalMPGC, nMPGC;


	VTSM_PGCI_UT=2048*GetNbytes(4,&pIFO[0xD0]);
	if ( VTSM_PGCI_UT==0)
		return;
	nTotalLU=GetNbytes(2,&pIFO[VTSM_PGCI_UT]);

	for (nLU=0 ; nLU<nTotalLU ; nLU++)
	{
		VTSM_LU=GetNbytes(4,&pIFO[VTSM_PGCI_UT+8+8*nLU+4])+VTSM_PGCI_UT;
		nTotalMPGC=GetNbytes(2,&pIFO[VTSM_LU]);

		for (nMPGC=0 ; nMPGC<nTotalMPGC; nMPGC++)
		{
			VTSM_PGC=GetNbytes(4,&pIFO[VTSM_LU+8+8*nMPGC+4])+VTSM_LU;
			Put4bytes(0, &pIFO[VTSM_PGC+8]);
		}
	}
}

int CAddChapterApp::ProcessIFO()
{
	int iRet,nPGC,i,j;
	int nVOBs,nTotADT,nChap;
	int nADT,VidADT;
	__int64 i64LBA;
	int LastByteIni,LastByte;
	int nStart,nIndex;

	m_maxVOBid=0;

	if (m_checkpuops )
	{
		RemoveMenuPUOPS(m_pVTS);
		for (nPGC=0; nPGC<m_nPGCs; nPGC++)
			Put4bytes(0, &m_pVTS[m_VTS_PGC[nPGC]+8]);
	}

	m_nTotalNewIFOSec=0;

	for (nPGC=0, m_nNewVids=0; nPGC<m_nPGCs; nPGC++)
	{
		if (m_BAdd[nPGC])
			m_nNewVids++;
	}

	nVOBs=GetNbytes(2,&m_pVTS[m_VTS_C_ADT]);
		
	LastByteIni=GetNbytes(4,&m_pVTS[m_VTS_C_ADT+4]);
	nTotADT=(LastByteIni-7)/12;

	if (m_checkonecell)
	{
		LastByte= 0;
		if (m_bAtLeastOneCustom)
			LastByte+=12;
		if (m_bAtLeastOneBlank)
			LastByte+=12;
		LastByte+=LastByteIni;
	}
	else
		LastByte= m_nNewVids*12*m_nChaptersToAdd + LastByteIni;

	Put4bytes( LastByte, &m_pVTS[m_VTS_C_ADT+4]);

	if (LastByte/2048 > LastByteIni/2048)
	{
//Move one sector (OR MORE)
		for (j=0; j< (LastByte/2048 - LastByteIni/2048); j++)
		{
			for (i= (int)m_i64VTSlen-1; i>=m_VTS_VOBU_ADMAP ; i--)
			{
				m_pVTS[i+2048]=m_pVTS[i];
			}
			if (GetNbytes(4,&m_pVTS[0xE4])!=0)
				Put4bytes(GetNbytes(4,&m_pVTS[0xE4])+1 , &m_pVTS[0xE4]);
			m_i64VTSlen+=2048;
			FillVTSvars();
			m_nTotalNewIFOSec++;
		}
	}

// Scan VTS_C_ADT, to find highest VobId
	for (nADT=0; nADT <nTotADT; nADT++)
	{
		VidADT=GetNbytes(2,&m_pVTS[m_VTS_C_ADT+8+12*nADT]);
		if (VidADT > m_maxVOBid) m_maxVOBid=VidADT;
	}
	m_iNewVidUniq=m_maxVOBid+1;


//////////////////////////////////////////////////////
// Process  VTS_C_ADT
	i64LBA=m_i64VTSsize/2048;
	if (m_checkonecell)
	{
		m_iNewVidUniq=m_maxVOBid+1;

		m_nNewBlank=m_nNewCustom=0;

		if (m_bAtLeastOneBlank)
		{
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT  ]=m_iNewVidUniq/256;
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+1]=m_iNewVidUniq%256;
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+2]=1; // CellID
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+3]=0; // Reserved
			Put4bytes (i64LBA  ,&m_pVTS[m_VTS_C_ADT+8+12*nTotADT+4]); 
			Put4bytes (i64LBA+4,&m_pVTS[m_VTS_C_ADT+8+12*nTotADT+8]); 

			for (nPGC=0; nPGC<m_nPGCs; nPGC++)
				if (m_iCellType[nPGC]==BLANK)
					m_iNewVid[nPGC]=m_iNewVidUniq;

			m_pVTS[m_VTS_C_ADT]=  (nVOBs+1)/256;
			m_pVTS[m_VTS_C_ADT+1]=(nVOBs+1)%256;
			nTotADT++;
			i64LBA+=5;
			m_iNewVidUniq++;
			m_nNewBlank=1;
		}
		if (m_bAtLeastOneCustom)
		{
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT  ]=m_iNewVidUniq/256;
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+1]=m_iNewVidUniq%256;
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+2]=1; // CellID
			m_pVTS[m_VTS_C_ADT+8+12*nTotADT+3]=0; // Reserved
			Put4bytes (i64LBA  ,&m_pVTS[m_VTS_C_ADT+8+12*nTotADT+4]); 
			Put4bytes (i64LBA+(int)m_i64CustomSize-1,&m_pVTS[m_VTS_C_ADT+8+12*nTotADT+8]); 

			for (nPGC=0; nPGC<m_nPGCs; nPGC++)
				if (m_iCellType[nPGC]==CUSTOM)
					m_iNewVid[nPGC]=m_iNewVidUniq;

			m_pVTS[m_VTS_C_ADT]=  (nVOBs+1)/256;
			m_pVTS[m_VTS_C_ADT+1]=(nVOBs+1)%256;
			m_nNewCustom=1;
		}
		m_iNewVidUniq=m_maxVOBid+1;
	}
	else
	{
		for (nPGC=0,m_nNewVids=m_nNewCustom=m_nNewBlank=0; nPGC<m_nPGCs; nPGC++)
		{
			for (m_nChap=0; m_nChap< m_nChaptersToAdd ;m_nChap++)
				{
				nStart=m_nNewBlank*5+m_nNewCustom*(int)m_i64CustomSize;

				nIndex=nTotADT+m_nNewVids*m_nChaptersToAdd+m_nChap;

				if (m_BAdd[nPGC] && m_iCellType[nPGC]==BLANK)
				{
					m_iNewVid[nPGC]=m_nNewVids+m_maxVOBid+1;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex]=m_iNewVid[nPGC]/256;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+1]=m_iNewVid[nPGC]%256;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+2]=m_nChap+1; // CellID
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+3]=0; // Reserved
					Put4bytes (i64LBA+nStart ,&m_pVTS[m_VTS_C_ADT+8+12*nIndex+4]); 
					Put4bytes (i64LBA+nStart+4,&m_pVTS[m_VTS_C_ADT+8+12*nIndex+8]); 
					m_nNewBlank++;
				}
				if (m_BAdd[nPGC] && m_iCellType[nPGC]!=BLANK)
				{

					m_iNewVid[nPGC]=m_nNewVids+m_maxVOBid+1;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex]=m_iNewVid[nPGC]/256;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+1]=m_iNewVid[nPGC]%256;
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+2]=m_nChap+1; // CellID
					m_pVTS[m_VTS_C_ADT+8+12*nIndex+3]=0; // Reserved
					Put4bytes (i64LBA+nStart  ,&m_pVTS[m_VTS_C_ADT+8+12*nIndex+4]); 
					Put4bytes (i64LBA+nStart+(int)m_i64CustomSize-1,&m_pVTS[m_VTS_C_ADT+8+12*nIndex+8]); 
					m_nNewCustom++;
				}
			}
			if (m_BAdd[nPGC] ) m_nNewVids++;
		}
		m_pVTS[m_VTS_C_ADT]=(nVOBs+m_nNewVids)/256;
		m_pVTS[m_VTS_C_ADT+1]=(nVOBs+m_nNewVids)%256;
	}


	m_i64LBA=m_i64VTSsize/2048;

	for (m_nChap=0; m_nChap< m_nChaptersToAdd ;m_nChap++)
	{
		iRet=FillVTSvars();
		if (iRet !=0) return iRet;

		m_nNewIFOSec=0;
		iRet=ProcessSingleIFO();
		if (iRet !=0) return iRet;
		m_nTotalNewIFOSec+=m_nNewIFOSec;
	}

	iRet=FillVTSvars();
	if (iRet !=0) return iRet;


//////////////////////////////////////////////////////
// Process VTS_VOBU_ADMAP

	i64LBA=m_i64VTSsize/2048;
	for (nPGC=0, m_nNewVids=0; nPGC<m_nPGCs; nPGC++)
	{
		if (m_BAdd[nPGC])
			m_nNewVids++;
	}
	LastByteIni=GetNbytes(4,&m_pVTS[m_VTS_VOBU_ADMAP]);
	if (m_checkonecell)
	{
		LastByte= 0;
		if (m_bAtLeastOneBlank)
			LastByte+=4;
		if (m_bAtLeastOneCustom)
			LastByte+=4;
		LastByte+=LastByteIni;
	}
	else
		LastByte=LastByteIni+4*m_nNewVids*m_nChaptersToAdd;

	if (LastByte/2048 > LastByteIni/2048)
	{
//Grow one sector (OR MORE)
		for (j=0; j< (LastByte/2048 - LastByteIni/2048); j++)
		{
			for (i= 0; i<2048 ; i++)
			{
				m_pVTS[i+(int)m_i64VTSlen]=0;
			}

			m_i64VTSlen+=2048;
			m_nTotalNewIFOSec++;
		}
	}


	Put4bytes(LastByte,&m_pVTS[m_VTS_VOBU_ADMAP]);

	if (m_checkonecell)
	{
		if (m_bAtLeastOneBlank)
			Put4bytes(i64LBA,&m_pVTS[m_VTS_VOBU_ADMAP+LastByteIni+1]);
		if (m_bAtLeastOneCustom)
		{
			if (m_bAtLeastOneBlank)
				Put4bytes(i64LBA+5,&m_pVTS[m_VTS_VOBU_ADMAP+LastByteIni+1]);
			else
				Put4bytes(i64LBA,&m_pVTS[m_VTS_VOBU_ADMAP+LastByteIni+1]);
		}
	}
	else
	{
		for ( i=0,nIndex=0; i<m_nPGCs ; i++)
		{
			for (nChap=0;nChap <m_nChaptersToAdd; nChap++)
			{
				if (m_BAdd[i])
				{
					Put4bytes(i64LBA,&m_pVTS[m_VTS_VOBU_ADMAP+LastByteIni+1+
					                  4*nIndex]);
					nIndex++;
				}
				if (m_BAdd[i] && m_iCellType[i]==BLANK)
					i64LBA+=5;
				if (m_BAdd[i] && m_iCellType[i]!=BLANK)
					i64LBA+=m_i64CustomSize;
			}
		}
	}

//////////////////////////////////////////////////////
//  Process Sectors: Only 0x0C is affected by VOB: 5 new sectors per Blank Cell
//					  m_nNewIFOSec

	Put4bytes(GetNbytes(4,&m_pVTS[0x1c])+m_nTotalNewIFOSec, &m_pVTS[0x1c]  );
	if ( GetNbytes(4,&m_pVTS[0xc0])!=0)
		Put4bytes(GetNbytes(4,&m_pVTS[0xc0])+m_nTotalNewIFOSec, &m_pVTS[0xc0]  );
	Put4bytes(GetNbytes(4,&m_pVTS[0xc4])+m_nTotalNewIFOSec, &m_pVTS[0xc4]  );

	if (m_checkonecell)
	{
		m_iSectorsAdded=m_nTotalNewIFOSec*2;
		if (m_bAtLeastOneBlank) m_iSectorsAdded+=5;
		if (m_bAtLeastOneCustom) m_iSectorsAdded+=(int)m_i64CustomSize;
	}
	else
		m_iSectorsAdded=(m_nNewBlank*5+m_nNewCustom*(int)m_i64CustomSize)+
		                  m_nTotalNewIFOSec*2;

	Put4bytes(GetNbytes(4,&m_pVTS[0x0c])+m_iSectorsAdded, &m_pVTS[0x0c]  );

	return 0;
}

int CAddChapterApp::ProcessSingleIFO()
{

	int nPGC,nChap;
//	int nADT,VidADT,nTotADT,nVOBs;
	int LastByteIni,LastByte;
	int nT,nTT,i;
	int LastOK;
//	int nStart;
	int nNewCustom,nNewBlank,nStart;


///////////////////////////////////////////////////
///////////////////////////////////////////////////
// Process PGCs
///////////////////////////////////////////////////
///////////////////////////////////////////////////
	LastByteIni=GetNbytes(4,&m_pVTS[m_VTS_PGCI+4]);
// 30 bytes will be added if original # programs is even
// 28 bytes will be added if original # programs is odd
	for (nPGC=0,LastByte=LastByteIni; nPGC<m_nPGCs; nPGC++)
		if (m_BAdd[nPGC])
		{
			LastByte+=28;
			if ((m_nPrograms[nPGC]%2)==0)
				LastByte+=2;
		}
	if (LastByte/2048 > LastByteIni/2048)
	{
//Move one sector
		for (i= (int)m_i64VTSlen-1; i>=m_VTSM_PGCI_UT ; i--)
		{
			m_pVTS[i+2048]=m_pVTS[i];
		}
		for (i=0xD0 ; i<= 0xE4 ; i+=4)
			if (GetNbytes(4,&m_pVTS[i])!=0)
				Put4bytes(GetNbytes(4,&m_pVTS[i])+1 , &m_pVTS[i]);
		m_i64VTSlen+=2048;
		FillVTSvars();
		m_nNewIFOSec++;
	}
	Put4bytes(LastByte,&m_pVTS[m_VTS_PGCI+4]);

	for (nPGC=0; nPGC<m_nPGCs; nPGC++)
	{
// Calculate nStart
		for (i=0,nNewCustom=nNewBlank=0; i<nPGC; i++)
		{
			for (nChap=0; nChap< m_nChaptersToAdd ;nChap++)
			{
				if (m_BAdd[i] && m_iCellType[i]==BLANK)
					nNewBlank++;
				if (m_BAdd[i] && m_iCellType[i]!=BLANK)
					nNewCustom++;
			}
		}
		for (nChap=0; nChap< m_nChap ;nChap++)
		{
			if (m_BAdd[i] && m_iCellType[i]==BLANK)
				nNewBlank++;
			if (m_BAdd[i] && m_iCellType[i]!=BLANK)
				nNewCustom++;
		}

		nStart=nNewBlank*5+nNewCustom*(int)m_i64CustomSize;
///////////////
		if (m_BAdd[nPGC])
		{
			m_pVTS[m_VTS_PGC[nPGC]+2]++;
			m_pVTS[m_VTS_PGC[nPGC]+3]++;

			// Move 2 byte (hole for program) if # prog is even 
			if ((m_nPrograms[nPGC]%2)==0)
			{
				for (i=m_VTS_PGCI+(LastByte/2048+1)*2048-1; i>= 	m_C_PBKT[nPGC]+2 ; i--)
				{
					m_pVTS[i]=m_pVTS[i-2];
				}
				m_C_PBKT[nPGC]+=2;
				m_C_POST[nPGC]+=2;
			}


			// Move 24 byte (hole for cell pbk)
			for (i=m_VTS_PGCI+(LastByte/2048+1)*2048-1; i>=m_C_POST[nPGC]+24 ; i--)
			{
				m_pVTS[i]=m_pVTS[i-24];
			}
			m_C_POST[nPGC]+=24;
			// Move 4 byte (hole for cell position)
			if (nPGC !=m_nPGCs-1)
			{
				for (i=m_VTS_PGCI+(LastByte/2048+1)*2048-1; i>=m_VTS_PGC[nPGC+1]+4+25 ; i--)
				{
					m_pVTS[i]=m_pVTS[i-4];
				}
			}
// Correct Duration
			if (m_iFormat==PAL)
			{
				m_dwCustomDuration=FramesToDuration(m_iCustomPTSDuration/(90000/25),25);
				if (m_iCellType[nPGC]==CUSTOM)
					m_dwDuration[nPGC]	= AddDuration(m_dwDuration[nPGC],m_dwCustomDuration);
				else
					m_dwDuration[nPGC]	= AddDuration(m_dwDuration[nPGC],0x52);
			}
			else
			{
				m_dwCustomDuration=FramesToDuration(m_iCustomPTSDuration/(90000/30),30);
				if (m_iCellType[nPGC]==CUSTOM)
					m_dwDuration[nPGC]	= AddDuration(m_dwDuration[nPGC],m_dwCustomDuration);
				else
					m_dwDuration[nPGC]	= AddDuration(m_dwDuration[nPGC],0xD5);
			}
			Put4bytes(m_dwDuration[nPGC],&m_pVTS[m_VTS_PGC[nPGC]+4]);


// Correct this PGC pointers
			Put2bytes(m_C_PBKT[nPGC]-m_VTS_PGC[nPGC],&m_pVTS[m_VTS_PGC[nPGC]+0xE8]);
			Put2bytes(m_C_POST[nPGC]-m_VTS_PGC[nPGC],&m_pVTS[m_VTS_PGC[nPGC]+0xEA]);

// Correct next PGCs pointers. nTT indexes next PGCs

			i=28;
			if ((m_nPrograms[nPGC]%2)==0) i+=2;
			for (nTT=nPGC+1 ; nTT < m_nPGCs ; nTT++)
			{
				m_VTS_PGC[nTT]+=i;
//				Put4bytes(m_VTS_PGC[nTT]-m_VTS_PGCI,&m_pVTS[m_VTS_PGCI+0x04+(nTT+1)*8]);
				Put4bytes( GetNbytes(4,&m_pVTS[m_VTS_PGCI+0x04+(nTT+1)*8])+i,
					&m_pVTS[m_VTS_PGCI+0x04+(nTT+1)*8]);
				m_C_POST[nTT]+=i;
				m_C_PBKT[nTT]+=i;
				m_PGM_MAP[nTT]+=i;
			}



// Fill program tables
			m_pVTS[m_PGM_MAP[nPGC]+m_nPrograms[nPGC]]=m_nCells[nPGC]+1;
			// if # prog is even fill with zero the next byte
			if ((m_nPrograms[nPGC]%2)==0)
				m_pVTS[m_PGM_MAP[nPGC]+m_nPrograms[nPGC]+1]=0;


// Fill position tables
			m_pVTS[m_C_POST[nPGC]+m_nCells[nPGC]*4  ]=m_iNewVid[nPGC]/256;
			m_pVTS[m_C_POST[nPGC]+m_nCells[nPGC]*4+1]=m_iNewVid[nPGC]%256;
			m_pVTS[m_C_POST[nPGC]+m_nCells[nPGC]*4+2]=0;
			if (m_checkonecell)
				m_pVTS[m_C_POST[nPGC]+m_nCells[nPGC]*4+3]=1;
			else
				m_pVTS[m_C_POST[nPGC]+m_nCells[nPGC]*4+3]=m_nChap+1;

// Fill playback tables

			Put4bytes(0x02000000, &m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24]);
			if (m_iCellType[nPGC]==CUSTOM) m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+2]=m_iStillTime[nPGC];

			if (m_iCellType[nPGC]==BLANK)
			{
				Put4bytes(0x52,			&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x04]);
				if (m_iFormat==NTSC)
					Put4bytes(0xD5,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x04]);
			}
			else
			{
				Put4bytes((__int64)m_dwCustomDuration,	&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x04]);
			}		
			if (!m_checkonecell)
			{
				Put4bytes(m_i64LBA+nStart,	&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x08]);
				Put4bytes(0,				&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x0C]);
				Put4bytes(m_i64LBA+nStart,	&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x10]);

				if (m_iCellType[nPGC]==CUSTOM )
					Put4bytes(m_i64LBA+nStart+(int)m_i64CustomSize-1,&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x14]);
				else
					Put4bytes(m_i64LBA+nStart+4,	&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x14]);
			}
			else
			{
				if (m_iCellType[nPGC]==BLANK)
				{
					Put4bytes(m_i64LBA,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x08]);
					Put4bytes(0,			&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x0C]);
					Put4bytes(m_i64LBA,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x10]);
					Put4bytes(m_i64LBA+4,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x14]);
				}
				else
				{
					if (m_bAtLeastOneBlank)
					{
						Put4bytes(m_i64LBA+5,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x08]);
						Put4bytes(0,			&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x0C]);
						Put4bytes(m_i64LBA+5,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x10]);
						Put4bytes(m_i64LBA+5+(int)m_i64CustomSize-1,&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x14]);
					}
					else
					{
						Put4bytes(m_i64LBA,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x08]);
						Put4bytes(0,			&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x0C]);
						Put4bytes(m_i64LBA,		&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x10]);
						Put4bytes(m_i64LBA+(int)m_i64CustomSize-1,&m_pVTS[m_C_PBKT[nPGC]+m_nCells[nPGC]*24+0x14]);
					}
				}
			}



		}
	}



//////////////////////////////////////////////////////
// Process VTS_PTT_SRPT
	for (nPGC=0, m_nNewVids=0; nPGC<m_nPGCs; nPGC++)
	{
		if (m_BAdd[nPGC])
			m_nNewVids++;
	}

	LastByteIni=GetNbytes(4,&m_pVTS[m_VTS_PTT_SRPT+4]);

	LastByte=LastByteIni+4*m_nNewVids;

	if (LastByte/2048 > LastByteIni/2048)
	{
//Move one sector
		for (i= (int)m_i64VTSlen-1; i>=m_VTS_PGCI ; i--)
		{
			m_pVTS[i+2048]=m_pVTS[i];
		}
		for (i=0xCC ; i<= 0xE4 ; i+=4)
			if (GetNbytes(4,&m_pVTS[i])!=0)
				Put4bytes(GetNbytes(4,&m_pVTS[i])+1 , &m_pVTS[i]);
		m_i64VTSlen+=2048;
		FillVTSvars();
		m_nNewIFOSec++;

	}

	Put4bytes(LastByte,&m_pVTS[m_VTS_PTT_SRPT+4]);

	for (nPGC=0; nPGC<m_nPGCs; nPGC++)
	{
		nT=m_nInVTS[nPGC]-1;

		FillVTSvars();

		for (nChap=0; nChap<m_nTChapters[nT]; nChap++)
		{
			if ((nPGC+1) == GetNbytes(2,&m_pVTS[m_VTS_PTT[nT]+4*nChap]) )
			{
				LastOK=m_VTS_PTT[nT]+4*nChap+4;
			}
		
		}

		if (m_BAdd[nPGC])
		{
		// Move 4 byte (hole for one PTT)
			for (i=m_VTS_PTT_SRPT+(LastByte/2048+1)*2048-1; i>=LastOK+4 ; i--)
			{
				m_pVTS[i]=m_pVTS[i-4];
			}
			m_pVTS[LastOK  ]=(nPGC+1)/256;
			m_pVTS[LastOK+1]=(nPGC+1)%256;
			m_pVTS[LastOK+2]=m_nPrograms[nPGC]/256;
			m_pVTS[LastOK+3]=m_nPrograms[nPGC]%256;

// HEADERS
			for (nTT=nT+1 ; nTT < m_nTitles ; nTT++)
			{
				m_VTS_PTT[nTT]+=4;
				Put4bytes(m_VTS_PTT[nTT]-m_VTS_PTT_SRPT,&m_pVTS[m_VTS_PTT_SRPT + 8+4*nTT]);
			}
		}
	}
	return 0;
}


int CAddChapterApp::ProcessVMG()
{
	int k,Sector,nVTS,nT,nChap,nPGC;

	m_TT_SRPT		=	2048*GetNbytes(4,&m_pVMG[0xC4]);
	m_nTotalTitles	=	GetNbytes(2,&m_pVMG[m_TT_SRPT]);

	if (m_checkpuops)
		RemoveMenuPUOPS(m_pVTS);
//////////////////////////////////////////////////////
// TT_SRPT: Table of titles
//	m_nNewVids*5 sectors to be added from m_nVTS
///////////////////////////////////////////////////////
// Titles loop
	for (k=0;k< m_nTotalTitles ; k++)
	{
		nVTS=GetNbytes(1,&m_pVMG[m_TT_SRPT+8+12*k+6]);
		nT=GetNbytes(1,&m_pVMG[m_TT_SRPT+8+12*k+7])-1;
		Sector=GetNbytes(4,&m_pVMG[m_TT_SRPT+8+12*k+8]);
		if (nVTS > m_nVTS)
			Put4bytes(Sector+ m_iSectorsAdded,&m_pVMG[m_TT_SRPT+8+12*k+8]);
		if (nVTS == m_nVTS )
		{
			for (nPGC=0; nPGC <m_nPGCs ; nPGC++)
			{
				if (nT == m_nInVTS[nPGC]-1 && m_BAdd[nPGC])
				{
					nChap=GetNbytes(2,&m_pVMG[m_TT_SRPT+8+12*k+2]);
					Put2bytes(nChap+m_nChaptersToAdd,&m_pVMG[m_TT_SRPT+8+12*k+2]);
				}
			}
		}

	}

	return 0;
}


int CAddChapterApp::ProcessVOB()
{
	int i,j, nPGC;
	uchar buffer[2050];
	__int64 i64LBA;
	CString csAux;
	FILE *out, *in;
	int nChap;

	if (m_nNewVids==0)
		return 0;
	if (m_checkappend)
	{
		if ((m_i64LastVOBSize/2048+m_iSectorsAdded) > 512*2048*1024-1)
		{
			m_checkappend=false;
			MyInfoBox ("Append cells will cause last VOB file to be higher than 1GB, so creating a new file");
		}
	}
	if (m_checkappend) 
	{
		csAux.Format(_T("VTS_%02d_%d.VOB"), m_nVTS, m_nVOBs);
		out=fopen(m_csInputPath + '\\' + csAux,"ab"); 
	}
	else
	{
		csAux.Format(_T("VTS_%02d_%d.VOB"), m_nVTS, m_nVOBs+1);
		out=fopen(m_csInputPath + '\\' + csAux,"wb"); 
	}

	if (out==NULL)
	{
		MyErrorBox ("Unable to open VOB file: " + csAux +".Aborting.");
		return -1;
	}

// Get Last NavPack 
	i64LBA=m_i64VTSsize/2048;

	if (m_checkonecell)
	{
		if (m_bAtLeastOneBlank)
		{
			for (i=0;i<5; i++)
			{
				for (j=0; j< 2048; j++)
					buffer[j]=SimpleVob[i*2048+j];
				if (IsNav(buffer))
				{
					ModifyLBA (buffer,i64LBA);
					ModifyCID (buffer,m_iNewVidUniq, 1);
				}
				i64LBA++;
				writebuffer(buffer,out);
			}		
			m_iNewVidUniq++;
		}
		if (m_bAtLeastOneCustom)
		{
			in=fopen(m_csCellPath,"rb"); 

			if (in==NULL)
			{
				MyErrorBox ("Unable to open VOB file: " + m_csCellPath +".Aborting.");
				return -1;
			}

			while (readbuffer(buffer,in)==2048)
			{
				if (!IsSynch(buffer))
				{
					MyErrorBox ("VOB unsynchronized. Aborting.");
					return -1;
				}

				if (IsNav(buffer))
				{
					ModifyLBA (buffer,i64LBA);
					ModifyCID (buffer,m_iNewVidUniq, 1);
				}
				i64LBA++;
				writebuffer(buffer,out);
			}
			fclose (in);
		}
	}
	else 
	{
		for (nPGC=0; nPGC<m_nPGCs; nPGC++)
		{
			if (m_BAdd[nPGC])
			{
				for(nChap=0; nChap <m_nChaptersToAdd; nChap++)
				{
					if (m_iCellType[nPGC]==BLANK)
					{
						for (i=0;i<5; i++)
						{
							for (j=0; j< 2048; j++)
								buffer[j]=SimpleVob[i*2048+j];
							if (IsNav(buffer))
							{
								ModifyLBA (buffer,i64LBA);
								ModifyCID (buffer,m_iNewVid[nPGC], nChap+1);
							}
							i64LBA++;
							writebuffer(buffer,out);
						}
					}
	
					if (m_iCellType[nPGC]==CUSTOM)
					{
						in=fopen(m_csCellPath,"rb"); 
	
						if (in==NULL)
						{
							MyErrorBox ("Unable to open VOB file: " + m_csCellPath +".Aborting.");
							return -1;
						}

						while (readbuffer(buffer,in)==2048)
						{
							if (!IsSynch(buffer))
							{
								MyErrorBox ("VOB unsynchronized. Aborting.");
								return -1;
							}
							if (IsNav(buffer))
							{
								ModifyLBA (buffer,i64LBA);
								ModifyCID (buffer,m_iNewVid[nPGC], nChap+1);
							}
							i64LBA++;
							writebuffer(buffer,out);
						}
						fclose (in);
					}
				}
			}
		}
	}

	fclose(out);

	return 0;
}


int CAddChapterApp::ExitInstance()
{
	int ret;

	ret= CWinApp::ExitInstance();
	return ret;

}


CString CAddChapterApp::VideoAttr() 
{
	CString csAux;

	m_iFormat=(m_iVideoAttr & 0x1000) >> 12;

	if (m_iFormat == 0 ) csAux="NTSC";
	else csAux="PAL ";
	{
	if ((m_iVideoAttr & 0x0C00) == 0x0C00 ) csAux+=" 16:9";
	else if ((m_iVideoAttr & 0x0C00) == 0 ) csAux+="   4:3";
	else csAux+=" unkn";
	}
	if ((m_iVideoAttr & 0x1000) == 0 )
	{
		if ((m_iVideoAttr & 0x0C) == 0 ) csAux+=" 720x480";
		if ((m_iVideoAttr & 0x0C) == 0x04 ) csAux+=" 704x480";
		if ((m_iVideoAttr & 0x0C) == 0x08 ) csAux+=" 352x480";
		if ((m_iVideoAttr & 0x0C) == 0x0C ) csAux+=" 352x240";
	}
	else 
	{
		if ((m_iVideoAttr & 0x0C) == 0 ) csAux+=" 720x576";
		if ((m_iVideoAttr & 0x0C) == 0x04 ) csAux+=" 704x576";
		if ((m_iVideoAttr & 0x0C) == 0x08 ) csAux+=" 352x576";
		if ((m_iVideoAttr & 0x0C) == 0x0C ) csAux+=" 352x288";
	}

	return csAux;

}

void CAddChapterApp::FillSimpleVob() 
{
	int i;
// Prepare SimpleVob
// DAR is hacked in MPEG header, but resolution cannot be hacked,
//	it will not work, so different simple Vobs have been created.
// All resolutions (included VCD) are coded in MPEG-2
	
	if ((m_iVideoAttr & 0x1000) == 0 )
	{
//		if ((m_iVideoAttr & 0x0C) == 0 )
		for (i=0;i<2048*5;i++) SimpleVob[i]=NtscSimpleVob720x480[i];

		if ((m_iVideoAttr & 0x0C) == 0x04 )
			for (i=0;i<2048*5;i++) SimpleVob[i]=NtscSimpleVob704x480[i];
		if ((m_iVideoAttr & 0x0C) == 0x08 )
			for (i=0;i<2048*5;i++) SimpleVob[i]=NtscSimpleVob352x480[i];
		if ((m_iVideoAttr & 0x0C) == 0x0C ) 
			for (i=0;i<2048*5;i++) SimpleVob[i]=NtscSimpleVob352x240[i];
	}
	else 
	{
//		if ((m_iVideoAttr & 0x0C) == 0 )
		for (i=0;i<2048*5;i++) SimpleVob[i]=PalSimpleVob720x576[i];
		if ((m_iVideoAttr & 0x0C) == 0x04 )
			for (i=0;i<2048*5;i++) SimpleVob[i]=PalSimpleVob704x576[i];
		if ((m_iVideoAttr & 0x0C) == 0x08 )
			for (i=0;i<2048*5;i++) SimpleVob[i]=PalSimpleVob352x576[i];
		if ((m_iVideoAttr & 0x0C) == 0x0C )
			for (i=0;i<2048*5;i++) SimpleVob[i]=PalSimpleVob352x288[i];
	}

	if ((m_iVideoAttr & 0x0C00) == 0x0C00 )
		//16:9
		SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048+3]=
		       (SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048+3] & 0x0F)+0x30;
	else if ((m_iVideoAttr & 0x0C00) == 0 )
		//4:3
		SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048+3]=
		       (SimpleVob[0x17+SimpleVob[0x16+2048]+4+2048+3] & 0x0F)+0x20;
}
