#include "stdafx.h"

typedef unsigned char uchar;


void MyErrorBox(LPCTSTR text)
{
	AfxMessageBox(text,MB_OK|MB_ICONEXCLAMATION,0);
}

void MyInfoBox(LPCTSTR text)
{
	AfxMessageBox(text,MB_OK|MB_ICONINFORMATION,0);
}


CString Size_MBytes(__int64 i64size)
{
	CString csAux;

	if (i64size < 9999)
		csAux.Format(_T("%I64d By"),i64size);
	else if (i64size < 9999*1024)
		csAux.Format(_T("%I64d KB"),i64size/1024);
	else if (i64size < (__int64)9999*1024*1024)
		csAux.Format(_T("%I64d MB"),i64size/1024/1024);
	else
		csAux.Format(_T("%I64d MB"),i64size/1024/1024/1024);
	
	return csAux;


}

CString FormatDuration(DWORD duration)
{
	CString csAux;

	csAux.Format(_T("%02X:%02X:%02X.%02X"),
		duration/(256*256*256),(duration/(256*256))%256,(duration/256)%256,(duration%256) & 0x3f);

	return csAux;
}

int GetNbytes(int nNumber,uchar* address)
{
	int ret,i;

	for (i=ret=0;i<nNumber;i++)
		ret=ret*256+address[i];
	return ret;
}

void Put4bytes(__int64 i64Number,uchar* address)
{

	address[0]= (uchar) (i64Number/(256*256*256));
	address[1]= (uchar) ((i64Number/(256*256))%256);
	address[2]= (uchar) ((i64Number/256)%256);
	address[3]= (uchar) (i64Number%256);

}

void Put2bytes(__int64 i64Number,uchar* address)
{

	address[0]= (uchar) ((i64Number/256)%256);
	address[1]= (uchar) (i64Number%256);

}


int BCD2Dec ( int BCD)
{
	int ret;
	ret = (BCD/0x10)*10 + (BCD%0x10);
	return ret;
}

int Dec2BCD ( int Dec)
{
	int ret;
	ret = (Dec/10)*0x10 + (Dec%10);
	return ret;
}

int DurationInSecs(DWORD dwDuration)
{

	int ifps,ret;
	__int64 i64Dur;

	if ( ((dwDuration%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur=  (BCD2Dec( (dwDuration%256) & 0x3f));
	i64Dur+= (BCD2Dec( (dwDuration/256)%256 )*ifps);
	i64Dur+= (BCD2Dec( (dwDuration/(256*256))%256 )*ifps*60);
	i64Dur+= (BCD2Dec(  dwDuration/(256*256*256)  )*ifps*60*60);

	ret=(int)(i64Dur/ifps);

	return ret;
}

DWORD FramesToDuration(int nFrames,int fps)
{
	DWORD dwDuration;
	int hh,mm,ss,ff;


	if (fps!=30 && fps !=25)
		fps=25;

	ff=Dec2BCD( (int)(nFrames%fps)     );
	ss=Dec2BCD( (int)((nFrames/fps)%60)   );
	mm=Dec2BCD( (int)((nFrames/fps/60)%60) );
	hh=Dec2BCD( (int)(nFrames/fps/60/60)  );

	dwDuration=ff + ss*256 + mm*256*256 + hh*256*256*256;

	if (fps==30)
		dwDuration+= 0x0c0;
	else
		dwDuration+= 0x040;

	return dwDuration;
}

DWORD AddDuration(DWORD dwDuration1, DWORD dwDuration2)
{
	DWORD ret;
	int ifps,hh,mm,ss,ff;
	__int64 i64Dur1, i64Dur2, i64DurT;

	if ( ((dwDuration1%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;
	
	i64Dur1=  BCD2Dec( (dwDuration1%256) & 0x3f);
	i64Dur1+= BCD2Dec( (dwDuration1/256)%256 )*ifps;
	i64Dur1+= BCD2Dec( (dwDuration1/(256*256))%256 )*ifps*60;
	i64Dur1+= BCD2Dec( dwDuration1/(256*256*256) )*ifps*60*60;

	i64Dur2=  BCD2Dec( (dwDuration2%256) & 0x3f);
	i64Dur2+= BCD2Dec( (dwDuration2/256)%256 )*ifps;
	i64Dur2+= BCD2Dec( (dwDuration2/(256*256))%256 )*ifps*60;
	i64Dur2+= BCD2Dec( dwDuration2/(256*256*256) )*ifps*60*60;

	i64DurT=i64Dur2+i64Dur1;

	ff=Dec2BCD( (int)(i64DurT%ifps)     );
	ss=Dec2BCD( (int)((i64DurT/ifps)%60)   );
	mm=Dec2BCD( (int)((i64DurT/ifps/60)%60) );
	hh=Dec2BCD( (int)(i64DurT/ifps/60/60)  );

	ret=ff + ss*256 + mm*256*256 + hh*256*256*256;

	if (ifps==30)
		ret+= 0x0c0;
	else
		ret+= 0x040;

	return ret;
}

CString SelectFolder (CString csTitulo)
{
	BROWSEINFO bi;
    LPITEMIDLIST pidlBrowse;    
	char	buffer[_MAX_PATH];
	char	path[_MAX_PATH];

	bi.hwndOwner = AfxGetMainWnd()->m_hWnd;     
	bi.pidlRoot = NULL; 
	bi.pszDisplayName = buffer;     
	bi.lpszTitle = (const char*)csTitulo; 
	bi.ulFlags = BIF_EDITBOX;
	//BIF_USENEWUI;     
	bi.lpfn = NULL;     
	bi.lParam = 0;  
	pidlBrowse = SHBrowseForFolder(&bi);     
	if (pidlBrowse != NULL) 
	{ 
		SHGetPathFromIDList(pidlBrowse,path);
		return CString(path);
	}
	return "";
}

int readbuffer(uchar *caracter, FILE *in)
{
	int j;
	
	j =fread (caracter,sizeof (uchar), 2048, in);


	return j;
}


void writebuffer(uchar *caracter, FILE *out)
{

	fwrite (caracter,sizeof(uchar),2048,out);

	return;
}


bool IsNav(uchar* buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[14]);

	if (startcode==443) return true;
	else return false;

}

bool IsSynch (uchar* buffer)
{

	int startcode;

	startcode=GetNbytes(4, &buffer[0]);

	if (startcode==0x1BA) return true;
	else return false;

}

void ModifyLBA (uchar* buffer, __int64 m_i64OutputLBA)
{
// 1st lba number
	buffer[0x30]= (uchar)(m_i64OutputLBA%256);
	buffer[0x2F]= (uchar)((m_i64OutputLBA/256)%256);
	buffer[0x2E]= (uchar)((m_i64OutputLBA/256/256)%256);
	buffer[0x2D]= (uchar)(m_i64OutputLBA/256/256/256);

// 2nd lba number
	buffer[0x040E]=buffer[0x30];
	buffer[0x040D]=buffer[0x2F];
	buffer[0x040C]=buffer[0x2E];
	buffer[0x040B]=buffer[0x2D];
}

void ModifyCID (uchar* buffer, int VobId, int CellId)
{
// VobID
	buffer[0x420]=(uchar)(VobId%256);
	buffer[0x41F]=(uchar)(VobId/256);
//CellID
	buffer[0x422]= (uchar) CellId;
}

void ModifyPUOPS (uchar* buffer)
{
	buffer[0x35]=0;
	buffer[0x36]=0;
	buffer[0x37]=0;
	buffer[0x38]=0;
}



/////////////////TO COPY PART OF THE CODE....

/*
		for (i64=0;!feof(in) ;i64++)
	{
		for (j=0; j<2048;j++)
			caracter[j]=fgetc(in);
		if (!feof(in))
		{
			if (!(caracter[0]==00 && caracter [1]==00 && caracter[2]==01 && caracter[3]==0xBA))
			{
				fprintf (stderr,"Error: LBA %I64d unsynchronized\n", i64);
				fprintf (log,"Error: LBA %I64d unsynchronized\n", i64);
				return 1;
			}
			startcode=((caracter[14]*256+ caracter[15])*256+ caracter[16])*256+ caracter[17];
 // subpicture/audio pack
			if (startcode==445)
			{
				st_i=0x17+caracter[0x16];
				if ( caracter[st_i] >0x1f && caracter[st_i] <0x30 )
				{
					nusubs++;
					if (extractsubs) writepack(caracter);
				}
				else
				{
					if (caracter[st_i] >0x7f)
					{

// ATENCION Streams conocidos son:
/*
0x80-0x87: ac3
0x88-0x8f: dts
0x90-0x9f: unknown
0xa0-0xa7: lpcm
0xa8-0xaf: unknown
0xb0-0xbf: unknown
0xc0-0xc8: mpeg1
0xc9-0xcf: mpeg2
0xd0-0xdf: unknown
0xe0-0xef: unknown
0xf0-0xff: unknown
*/
/*
						nuaudio++;
						if (extractaudio) writepack(caracter);
					}
					else
						nuundef2++;
				}
			}
//  videopack
			else if (startcode==480)
			{
				nuvideo++;
				if (extractvideo) writepack(caracter);
			}
//  Navpack
			else if (startcode==443)
			{
				nunav++;
				if (extractnav)     writepack(caracter);
				if (changevobid)    writepackvobid(caracter,vobini,vobnew);
				if (extractnavinfo) writenavinfo(caracter, i64);
			}
			else
				nuundef1++;
		}

*/

/*
void writenavinfo(int *caracter, __int64 lba)
{

	// There are two different times (but most of the cases identical)
	// PCI stream and DSI stream 
	// VOBID and CELLID are in DSI header
	int vobid, cellid;
	int hh,mm,ss,ff;
	int hor, min, sec, fra, fps;
	int seconds,frames;
	__int64 this_lba;
	int diff, diffold;
	static int fraold=0;


	this_lba= (((__int64)caracter[0x2d]*256 +
		        (__int64)caracter[0x2e])*256 +
				(__int64)caracter[0x2f])*256 +
				(__int64)caracter[0x30];

	hh=caracter[0x45];
	mm=caracter[0x46];
	ss=caracter[0x47];
	ff=caracter[0x48];
	
	hor= (hh/16)*10 + hh%16;
	min= (mm/16)*10 + mm%16;
	sec= (ss/16)*10 + ss%16;
	fra= ((ff/16) & 0x3 )*10 + ff%16;
	fps=0;
	if ((ff & 0xc0 ) == 0x40 ) fps=25;
	if ((ff & 0xc0 ) == 0xc0 ) fps=30;

	seconds= hor*3600+min*60+sec;
	frames = seconds*fps +fra;

    diff   = frames -fraold;
	fraold = frames;
	diffold = diff;

	vobid=caracter[0x41f]*256 + caracter[0x420];
	cellid=caracter[0x422];
	

	fprintf (out,"V/C:%02d%02d this:%08I64X lba:%08I64X sec=%06d fra=%06d time: %02X:%02X:%02X.%02X diff:%04d\n",
		     vobid, cellid, this_lba, lba, seconds, frames, hh,mm,ss,ff&0x3f, diff);
	totwr++;
}
*/


/* Code of TMAPTI 

#define PERCDUR 95
#define MAXENTRIESLOST 2
#define WRITEBUP 1


int ifo_sour[MAXLENGTH];
__int64 length_sour;
int discontinuity;

int readline (char *line, FILE *file)
{
	if ((fgets (line,1024,file))==NULL)
		 return 1;
	return 0;
}

unsigned __int64 findlba(long int sec, long int vobid, long int cellid, FILE *file)
{

//	V/C:0201 this:00007B35 lba:00000000 sec=000000 fra=000000 time: 00:00:00.00 diff:0000

	char linea[1024];
	int match;
	char vobstr[32];
	unsigned __int64 lba;
	char *pcr;
	long int secread;
	static long int secold=0, secacum=0;

	lba=0xFFFFFFFF;
	match=0;
	if (cellid ==0)
	   sprintf (vobstr,"V/C:%02d",vobid);
	else
	   sprintf (vobstr,"V/C:%02d%02d",vobid,cellid);

    while ( match == 0)
	{
		if (readline (linea, file)!=0) match =-1;
		else if (strstr (linea,vobstr) !=NULL) 
		{
			pcr= strstr(linea,"sec=");
			pcr+=4;
			pcr[6]=0;
			sscanf (pcr, "%ld",&secread);

			if (secread < secold)
			{
				discontinuity=1;
				secacum+=secold;
			}
			secold=secread;

			if ( secread+secacum>=sec )
			{
				match =1;
				pcr= strstr(linea,"this:");
				pcr+=5;
				pcr[8]=0;
				sscanf (pcr, "%I64X",&lba);
			}
		}
	}

	return lba;
}


int	writeifo (char* file_out)
{
	FILE *out;
	long int i;
	if ((out=fopen(file_out,"wb"))==NULL)
	{
		fprintf (stderr,"Unable to open output file: %s\n",file_out);
		return 1;
	}

	if (fseek(out,0,SEEK_SET)!=0)
	{
		fclose(out);
		fprintf (stderr,"Unable to positioning in output file\n");
		return 1;
	}
	for (i=0; i< length_sour; i++)
		fputc(ifo_sour[i],out);
	fclose(out);

//	fprintf (stderr, "IFO written. %ld characters\n", length_sour);
	return 0;
}


__int64 readifo (char* file, int *ifo_mem)
{
	__int64 i, length;
	FILE *in;

	if ((in=fopen(file,"rb"))==NULL)
	{
		fprintf (stderr,"Unable to open input file %s\n",file);
		return -1;
	}


	for (i=0;!feof(in) && i< MAXLENGTH ;i++)
		ifo_mem[i]=fgetc(in);
	length=i-1;
	
	fclose(in);

	if (length == MAXLENGTH-1)
	{
		fprintf (stderr, "ERROR: Ifo file too big\n");
		return -1;
	}
	return length;
}

/////////////////////////////////////////////////////////////
//    main
/////////////////////////////////////////////////////////////
int main(int argc, char* argv[])
{

	long int pgc, nusecs, vobid, cellid; 
    char file_out[256];
	long int i;
	long int VTS_PGCI_ini,VTS_PGC_ini, VTS_TMAPTI_ini, VTS_TMAP_ini, VTS_TMAP_end;
	long int nuPGCs, nuPGCs_TMAP;
	long int duration, hh, mm,ss;
	long int maxentries, entries, entriesok;
	unsigned __int64 lba;

	FILE *inlst, *log;

	if (argc < 5 || 
		!( (strcmp (argv[1],"-pgc"))==0 ))
	{
		fprintf (stderr,"Usage: tmapti -pgc <nupgc> -vobid <nuvob> [-cellid <nucell>] [-secs <nusecs>] ifofilein lstfile\n");
		fprintf (stderr,"       Updates tmapti of ifo table according the selected parameters\n");
		fprintf (stderr,"               tmapti uses the space available, but does not make more space\n");
		fprintf (stderr,"       lstfile: file result of navpack -navinfo vob_file \n");
		fprintf (stderr,"       vobid and cellid (optional) select the vobid (and cellid) lbas to use\n");
		fprintf (stderr,"       pgc: selects the pgc table to be updated\n");
		fprintf (stderr,"       -secs sets the number of seconds between the entries\n");
		fprintf (stderr,"             -1 uses the already stored value\n");
		fprintf (stderr,"              0 calculates a safe value\n");
			
	// nusecs=0  means automatic detection 
		return 1;
	}

	pgc=nusecs=vobid=cellid=0;

	for (i=1; i< (long int)(argc-2) ;i++)
	{
		if (strcmp (argv[i],"-pgc")==0)	  {sscanf(argv[i+1],"%ld", &pgc); i++;}
		if (strcmp (argv[i],"-secs")==0)  {sscanf(argv[i+1],"%ld", &nusecs); i++;}
		if (strcmp (argv[i],"-vobid")==0) {sscanf(argv[i+1],"%ld", &vobid); i++;}
		if (strcmp (argv[i],"-cellid")==0) {sscanf(argv[i+1],"%ld", &cellid); i++;}

	}

	if (pgc < 1 || vobid < 1 || cellid<0 )
	{
		fprintf (stderr,"PGC and VOBID numbers must be higher than 0\n");
		return 1;
	}

// readifo

	if ( (length_sour=readifo(argv[argc-2],ifo_sour)) == -1) return (1);

// openlst

	if ((inlst=fopen(argv[argc-1],"r"))==NULL)
	{
		fprintf (stderr,"Unable to open input lst file %s\n",argv[argc-1]);
		return -1;
	}
	if ((log=fopen("tmapti.log","w"))==NULL)
	{
		fprintf (stderr,"Unable to open log file %s\n","tmapti.log");
		return -1;
	}
	

	strcpy(file_out,argv[argc-2]); // ready to write original ifo

// Pointers to Tables
	VTS_PGCI_ini=2048*(((ifo_sour[0xCC]*256+ifo_sour[0xCD])*256+
			                ifo_sour[0xCE])*256+ifo_sour[0xCF]);
	
	VTS_TMAPTI_ini=2048*(((ifo_sour[0xD4]*256+ifo_sour[0xD5])*256+
			                ifo_sour[0xD6])*256+ifo_sour[0xD7]);

// locate selected PGC 
	if ( VTS_PGCI_ini > length_sour || VTS_TMAPTI_ini > length_sour)
	{
		fprintf (stderr,"ERROR: Unable to locate VTS Tables\n");
		return 1;
	}

	nuPGCs=ifo_sour[VTS_PGCI_ini]*256+ifo_sour[VTS_PGCI_ini+1];

	if ( nuPGCs < pgc)
	{
		fprintf (stderr,"ERROR: Unable to find source PGCs\n");
		return 1;
	}

	VTS_PGC_ini=((ifo_sour[VTS_PGCI_ini+0x04+pgc*8]*256+ifo_sour[VTS_PGCI_ini+0x05+pgc*8])*256+
		        ifo_sour[VTS_PGCI_ini+0x06+pgc*8])*256+ifo_sour[VTS_PGCI_ini+0x07+pgc*8]+
				VTS_PGCI_ini;

	hh=ifo_sour[VTS_PGC_ini+4];
	mm=ifo_sour[VTS_PGC_ini+5];
	ss=ifo_sour[VTS_PGC_ini+6];
	duration= ((hh/16)*10+(hh%16))*3600 + ((mm/16)*10+(mm%16))*60 + ((ss/16)*10+(ss%16));

// locate selected TMAP

	nuPGCs_TMAP=ifo_sour[VTS_TMAPTI_ini]*256+ifo_sour[VTS_TMAPTI_ini+1];
	if ( nuPGCs !=  nuPGCs_TMAP)
	{
		fprintf (stderr,"ERROR: nuPGCs mismatch between VTS_TMAPTI and VTS_PGCI. Please fix it manually\n");
		return 1;
	}

	VTS_TMAP_ini=((ifo_sour[VTS_TMAPTI_ini+0x04+pgc*4]*256+ifo_sour[VTS_TMAPTI_ini+0x05+pgc*4])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x06+pgc*4])*256+ifo_sour[VTS_TMAPTI_ini+0x07+pgc*4]+
				VTS_TMAPTI_ini;

// locate the limits of TMAP table
	if (nuPGCs == pgc)
		// last PGC, so use last available byte
		VTS_TMAP_end=((ifo_sour[VTS_TMAPTI_ini+0x04]*256+ifo_sour[VTS_TMAPTI_ini+0x05])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x06])*256+ifo_sour[VTS_TMAPTI_ini+0x07]+
				VTS_TMAPTI_ini;
	else
		// first byte of next PGC
		VTS_TMAP_end=((ifo_sour[VTS_TMAPTI_ini+0x08+pgc*4]*256+ifo_sour[VTS_TMAPTI_ini+0x09+pgc*4])*256+
		        ifo_sour[VTS_TMAPTI_ini+0x0A+pgc*4])*256+ifo_sour[VTS_TMAPTI_ini+0x0B+pgc*4]+
				VTS_TMAPTI_ini - 1;

    maxentries=(VTS_TMAP_end-VTS_TMAP_ini+1)/4 -1;

	// nusecs=-1 uses already stored value
	if (nusecs == -1 ) nusecs= ifo_sour[VTS_TMAP_ini];
	// nusecs=0  means automatic detection 
	// Too many operations, sure there is an easy way to do the same...
	if (nusecs == 0 && maxentries !=0)
	{
		nusecs=duration/maxentries;
		if (nusecs == 0)  nusecs=1;
		entries= duration/nusecs;
		if (entries > maxentries+MAXENTRIESLOST)
			nusecs= (duration*PERCDUR/100)/maxentries*100;
	}

	// to be sure 
	if (nusecs == 0)  nusecs=1;
	entries= duration/nusecs;

// log some info
	fprintf (log, "pgc:%02d vobid:%02d nusecs:%02d entries:%04d maxentries:%04d duration:%06d\n",
		           pgc, vobid, nusecs, entries, maxentries, duration);

	for (i=entriesok=0; i<duration; i+=nusecs)
	{
		discontinuity=0;
		lba=findlba(i, vobid, cellid, inlst);
		if (discontinuity==1)
		{
			discontinuity=0;
			ifo_sour[VTS_TMAP_ini+entriesok*4]+=0x80;
		}
		if (lba!=0xFFFFFFFF  && entriesok <maxentries)
		{
			entriesok++;
			ifo_sour[VTS_TMAP_ini+entriesok*4+3]=(int)(lba%256);
			ifo_sour[VTS_TMAP_ini+entriesok*4+2]=(int)((lba%(256*256))/256);
			ifo_sour[VTS_TMAP_ini+entriesok*4+1]=(int)((lba%(256*256*256))/(256*256));
			ifo_sour[VTS_TMAP_ini+entriesok*4]=(int)(lba/(256*256*256));
			fprintf (log, "entry:%04d sec:%06d lba:%08I64X\n",
		                   entriesok, i, lba);
		}

	}
	// last entry always discontinuity. Not sure, but it seems... 
	if (entriesok > 0 ) ifo_sour[VTS_TMAP_ini+entriesok*4]+=0x80;

	ifo_sour[VTS_TMAP_ini+2]=entriesok/256;
	ifo_sour[VTS_TMAP_ini+3]=entriesok%256;
	ifo_sour[VTS_TMAP_ini]=nusecs;

	// write destination IFO
	writeifo (file_out);
	if (WRITEBUP)
	{
		file_out[strlen(file_out)-3]=0;
		strcat(file_out,"BUP");
		writeifo (file_out);
	}
	fclose (inlst);
	fclose (log);

	return 0;
}


*/ 
//End of TMAPTI code

